// -*- C++ -*-
/*!
 * @file  Change.cpp
 * @brief Change
 * @date $Date$
 *
 * $Id$
 */

#include "Change.h"


double Pos_x[4];
double Pos_y[4];
double Pos_z[4];
int flag=0;
double temp;
// Module specification
// <rtc-template block="module_spec">
static const char* change_spec[] =
  {
    "implementation_id", "Change",
    "type_name",         "Change",
    "description",       "Change",
    "version",           "1.0.0",
    "vendor",            "VenderName",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
Change::Change(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_CalibrationIn("m_Calibration_IP", m_Calibration),//
    m_Hand_PosIn("Hand_Position_IP", m_Hand_Pos),
    m_Hand_AngleIn("Hand_Angle_IP", m_Hand_Angle),
    m_Hand_OpenIn("Hand_Open_IP", m_Hand_Open),
    m_CHand_PosOut("CHand_Position_OP", m_CHand_Pos),
    m_CHand_AngleOut("CHand_Angle_OP", m_CHand_Angle),
    m_CHand_OpenOut("CHand_Open_OP", m_CHand_Open)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
Change::~Change()
{
}



RTC::ReturnCode_t Change::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("Calibration_IP", m_CalibrationIn);//
  addInPort("Hand_Position_IP", m_Hand_PosIn);
  addInPort("Hand_Angle_IP", m_Hand_AngleIn);
  addInPort("Hand_Open_IP", m_Hand_OpenIn);
  
  // Set OutPort buffer
  addOutPort("CHand_Position_OP", m_CHand_PosOut);
  addOutPort("CHand_Angle_OP", m_CHand_AngleOut);
  addOutPort("CHand_Open_OP", m_CHand_OpenOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t Change::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Change::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Change::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t Change::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Change::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Change::onExecute(RTC::UniqueId ec_id)
{
	double difference=0;

	if(m_CalibrationIn.isNew()){
		m_CalibrationIn.read();
		std::cout << "Calibration_y="<< m_Calibration.data.y << std::endl;
	}

	if(m_Hand_PosIn.isNew()){
		m_Hand_PosIn.read();
		std::cout << "x = " << m_Hand_Pos.data.x << ",y = " << m_Hand_Pos.data.y << " ,z = " << m_Hand_Pos.data.z << std::endl;
		if(flag==0){
			for(int i=0;i<5;i++){//ݒ
				Pos_x[i]=m_Hand_Pos.data.x;
				Pos_y[i]=m_Hand_Pos.data.y;
				Pos_z[i]=m_Hand_Pos.data.z;
				std::cout << "x = " << Pos_x[i] << ",y = " << Pos_y[i] << " ,z = " << Pos_z[i] << std::endl;
			}
			flag=1;
			std::cout << "flag= " << flag <<std::endl;
		}
		else{
			if(m_Hand_Pos.data.y>temp+10 || m_Hand_Pos.data.y<temp-10){//
				difference += Pos_y[4] - Pos_y[3];
				difference += Pos_y[3] - Pos_y[2];
				difference += Pos_y[2] - Pos_y[1];
				difference += Pos_y[1] - Pos_y[0];
				difference += Pos_y[0] - m_Hand_Pos.data.y;
				difference = difference / 5;

				std::cout << "difference = " << difference << std::endl;

				Pos_y[4] = Pos_y[3];
				Pos_y[3] = Pos_y[2];
				Pos_y[2] = Pos_y[1];
				Pos_y[1] = Pos_y[0];
				Pos_y[0] = m_Hand_Pos.data.y;
				//Pos_y[0] = Pos_y[0] + difference;
				temp =  Pos_y[1] + difference; 
				m_CHand_Pos.data.y = Pos_y[1] + difference; 
			}
			else{
				Pos_y[4] = Pos_y[3];
				Pos_y[3] = Pos_y[2];
				Pos_y[2] = Pos_y[1];
				Pos_y[1] = Pos_y[0];
				Pos_y[0] = m_Hand_Pos.data.y;
				temp = m_Hand_Pos.data.y;
				m_CHand_Pos.data.y = m_Hand_Pos.data.y; 
			}

			for(int i=0;i<5;i++){
				std::cout<<"Pos_y["<<i<<"] = "<<Pos_y[i]<<std::endl;
			}
			std::cout<<"Out = "<<m_CHand_Pos.data.y<<std::endl;

		}
	}


		if(m_Hand_AngleIn.isNew()){
			m_Hand_AngleIn.read();
			m_CHand_Angle = m_Hand_Angle;
		}
		if(m_Hand_OpenIn.isNew()){
			m_Hand_OpenIn.read();
			m_CHand_Open = m_Hand_Open;
		}


		m_CHand_PosOut.write();
		m_CHand_AngleOut.write();
		m_CHand_OpenOut.write();


		return RTC::RTC_OK;
	}

/*
RTC::ReturnCode_t Change::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Change::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Change::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Change::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Change::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void ChangeInit(RTC::Manager* manager)
  {
    coil::Properties profile(change_spec);
    manager->registerFactory(profile,
                             RTC::Create<Change>,
                             RTC::Delete<Change>);
  }
  
};


